Index: dna-graph/src/test/java/org/jboss/dna/graph/connectors/test/AbstractConnectorTest.java
===================================================================
--- dna-graph/src/test/java/org/jboss/dna/graph/connectors/test/AbstractConnectorTest.java	(revision 702)
+++ dna-graph/src/test/java/org/jboss/dna/graph/connectors/test/AbstractConnectorTest.java	(working copy)
@@ -34,7 +34,6 @@
 import java.util.UUID;
 import java.util.concurrent.TimeUnit;
 import org.jboss.dna.common.stats.Stopwatch;
-import org.jboss.dna.graph.BasicExecutionContextFactory;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.ExecutionContextFactory;
 import org.jboss.dna.graph.Graph;
@@ -84,7 +83,7 @@
             // Set up the connection factory to other sources ...
 
             // Set up the execution context ...
-            contextFactory = new BasicExecutionContextFactory();
+            contextFactory = new ExecutionContext();
             context = setUpExecutionContext(contextFactory);
 
             // Set up the source ...
Index: dna-graph/src/test/java/org/jboss/dna/graph/sequencers/MockSequencerContext.java
===================================================================
--- dna-graph/src/test/java/org/jboss/dna/graph/sequencers/MockSequencerContext.java	(revision 702)
+++ dna-graph/src/test/java/org/jboss/dna/graph/sequencers/MockSequencerContext.java	(working copy)
@@ -21,176 +21,19 @@
  */
 package org.jboss.dna.graph.sequencers;
 
-import java.security.AccessControlContext;
-import java.util.Set;
-import javax.security.auth.Subject;
-import javax.security.auth.login.LoginContext;
 import net.jcip.annotations.Immutable;
-import org.jboss.dna.common.collection.Problems;
 import org.jboss.dna.common.collection.SimpleProblems;
-import org.jboss.dna.common.util.Logger;
-import org.jboss.dna.graph.BasicExecutionContext;
-import org.jboss.dna.graph.DnaLexicon;
 import org.jboss.dna.graph.ExecutionContext;
-import org.jboss.dna.graph.mimetype.MimeTypeDetector;
-import org.jboss.dna.graph.properties.Name;
-import org.jboss.dna.graph.properties.NamespaceRegistry;
-import org.jboss.dna.graph.properties.Path;
-import org.jboss.dna.graph.properties.Property;
-import org.jboss.dna.graph.properties.PropertyFactory;
-import org.jboss.dna.graph.properties.ValueFactories;
 
 /**
  * @author John Verhaeg
  */
 @Immutable
-public class MockSequencerContext implements SequencerContext {
+public class MockSequencerContext extends SequencerContext {
 
-    private final ExecutionContext context = new BasicExecutionContext();
-    private final Problems problems = new SimpleProblems();
-
     public MockSequencerContext() {
-        NamespaceRegistry registry = context.getNamespaceRegistry();
-        registry.register("jcr", "http://www.jcp.org/jcr/1.0");
-        registry.register("mix", "http://www.jcp.org/jcr/mix/1.0");
-        registry.register("nt", "http://www.jcp.org/jcr/nt/1.0");
-        registry.register(DnaLexicon.Namespace.PREFIX, DnaLexicon.Namespace.URI);
-        registry.register("dnadtd", "http://www.jboss.org/dna/dtd/1.0");
-        registry.register("dnaxml", "http://www.jboss.org/dna/xml/1.0");
+        super(new ExecutionContext(), null, null, null, new SimpleProblems());
+        getNamespaceRegistry().register("dnadtd", "http://www.jboss.org/dna/dtd/1.0");
+        getNamespaceRegistry().register("dnaxml", "http://www.jboss.org/dna/xml/1.0");
     }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.common.component.ClassLoaderFactory#getClassLoader(java.lang.String[])
-     */
-    public ClassLoader getClassLoader( String... classpath ) {
-        return context.getClassLoader(classpath);
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.ExecutionContext#getMimeTypeDetector()
-     */
-    public MimeTypeDetector getMimeTypeDetector() {
-        return context.getMimeTypeDetector();
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.sequencers.SequencerContext#getInputPath()
-     */
-    public Path getInputPath() {
-        return null;
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.sequencers.SequencerContext#getInputProperties()
-     */
-    public Set<Property> getInputProperties() {
-        return null;
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.sequencers.SequencerContext#getInputProperty(org.jboss.dna.graph.properties.Name)
-     */
-    public Property getInputProperty( Name name ) {
-        return null;
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.sequencers.SequencerContext#getMimeType()
-     */
-    public String getMimeType() {
-        return null;
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.sequencers.SequencerContext#getProblems()
-     */
-    public Problems getProblems() {
-        return problems;
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.ExecutionContext#getAccessControlContext()
-     */
-    public AccessControlContext getAccessControlContext() {
-        return context.getAccessControlContext();
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.ExecutionContext#getLogger(java.lang.Class)
-     */
-    public Logger getLogger( Class<?> clazz ) {
-        return context.getLogger(clazz);
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.ExecutionContext#getLogger(java.lang.String)
-     */
-    public Logger getLogger( String name ) {
-        return context.getLogger(name);
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.ExecutionContext#getLoginContext()
-     */
-    public LoginContext getLoginContext() {
-        return context.getLoginContext();
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.ExecutionContext#getNamespaceRegistry()
-     */
-    public NamespaceRegistry getNamespaceRegistry() {
-        return context.getNamespaceRegistry();
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.ExecutionContext#getPropertyFactory()
-     */
-    public PropertyFactory getPropertyFactory() {
-        return context.getPropertyFactory();
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.ExecutionContext#getSubject()
-     */
-    public Subject getSubject() {
-        return context.getSubject();
-    }
-
-    /**
-     * {@inheritDoc}
-     * 
-     * @see org.jboss.dna.graph.ExecutionContext#getValueFactories()
-     */
-    public ValueFactories getValueFactories() {
-        return context.getValueFactories();
-    }
 }
Index: dna-graph/src/main/java/org/jboss/dna/graph/ExecutionContext.java
===================================================================
--- dna-graph/src/main/java/org/jboss/dna/graph/ExecutionContext.java	(revision 702)
+++ dna-graph/src/main/java/org/jboss/dna/graph/ExecutionContext.java	(working copy)
@@ -22,34 +22,173 @@
 package org.jboss.dna.graph;
 
 import java.security.AccessControlContext;
+import java.security.AccessController;
 import javax.security.auth.Subject;
+import javax.security.auth.callback.CallbackHandler;
 import javax.security.auth.login.LoginContext;
+import javax.security.auth.login.LoginException;
+import javax.security.auth.spi.LoginModule;
+import net.jcip.annotations.Immutable;
 import org.jboss.dna.common.component.ClassLoaderFactory;
+import org.jboss.dna.common.component.StandardClassLoaderFactory;
+import org.jboss.dna.common.util.CheckArg;
 import org.jboss.dna.common.util.Logger;
+import org.jboss.dna.graph.mimetype.ExtensionBasedMimeTypeDetector;
 import org.jboss.dna.graph.mimetype.MimeTypeDetector;
 import org.jboss.dna.graph.properties.NamespaceRegistry;
 import org.jboss.dna.graph.properties.Property;
 import org.jboss.dna.graph.properties.PropertyFactory;
 import org.jboss.dna.graph.properties.ValueFactories;
+import org.jboss.dna.graph.properties.basic.BasicNamespaceRegistry;
+import org.jboss.dna.graph.properties.basic.BasicPropertyFactory;
+import org.jboss.dna.graph.properties.basic.StandardValueFactories;
 
 /**
  * An ExecutionContext is a representation of the environment or context in which a component or operation is operating. Some
  * components require this context to be passed into individual methods, allowing the context to vary with each method invocation.
  * Other components require the context to be provided before it's used, and will use that context for all its operations (until
  * it is given a different one).
+ * <p>
+ * ExecutionContext instances are {@link Immutable immutable}, so components may hold onto references to them without concern of
+ * those contexts changing. However, contexts may be used to create other context with variations in the environment and/or
+ * security context. For example, an ExecutionContext could be used to create another context that references the same
+ * {@link #getNamespaceRegistry() namespace registry} but which has a different {@link #getSubject() JAAS subject}.
+ * </p>
  * 
  * @author Randall Hauch
  * @author John Verhaeg
- * @see ExecutionContextFactory
  */
-public interface ExecutionContext extends ClassLoaderFactory {
+@Immutable
+public class ExecutionContext implements ClassLoaderFactory, Cloneable, ExecutionContextFactory {
 
+    private final ClassLoaderFactory classLoaderFactory;
+    private final LoginContext loginContext;
+    private final AccessControlContext accessControlContext;
+    private final Subject subject;
+    private final PropertyFactory propertyFactory;
+    private final ValueFactories valueFactories;
+    private final NamespaceRegistry namespaceRegistry;
+    private final MimeTypeDetector mimeTypeDetector;
+
     /**
-     * @return the access control context; may be <code>null</code>
+     * Create an instance of an execution context that inherits the {@link AccessControlContext security context} from the
+     * {@link AccessController#getContext() current calling context}, with default implementations for all other components
+     * (including default namespaces in the {@link #getNamespaceRegistry() namespace registry}.
      */
-    AccessControlContext getAccessControlContext();
+    public ExecutionContext() {
+        this(null, null, null, null, null, null, null);
+        initializeDefaultNamespaces(this.getNamespaceRegistry());
+    }
 
     /**
+     * Create a copy of the supplied execution context.
+     * 
+     * @param original the original
+     * @throws IllegalArgumentException if the original is null
+     */
+    protected ExecutionContext( ExecutionContext original ) {
+        CheckArg.isNotNull(original, "original");
+        this.loginContext = original.getLoginContext();
+        this.accessControlContext = original.getAccessControlContext();
+        this.subject = original.getSubject();
+        this.namespaceRegistry = original.getNamespaceRegistry();
+        this.valueFactories = original.getValueFactories();
+        this.propertyFactory = original.getPropertyFactory();
+        this.classLoaderFactory = original.getClassLoaderFactory();
+        this.mimeTypeDetector = original.getMimeTypeDetector();
+    }
+
+    /**
+     * Create a copy of the supplied execution context, but use the supplied {@link AccessControlContext} instead.
+     * 
+     * @param original the original
+     * @param accessControlContext the access control context
+     * @throws IllegalArgumentException if the original or access control context are is null
+     */
+    protected ExecutionContext( ExecutionContext original,
+                                AccessControlContext accessControlContext ) {
+        CheckArg.isNotNull(original, "original");
+        CheckArg.isNotNull(accessControlContext, "accessControlContext");
+        this.loginContext = null;
+        this.accessControlContext = accessControlContext;
+        this.subject = Subject.getSubject(this.accessControlContext);
+        this.namespaceRegistry = original.getNamespaceRegistry();
+        this.valueFactories = original.getValueFactories();
+        this.propertyFactory = original.getPropertyFactory();
+        this.classLoaderFactory = original.getClassLoaderFactory();
+        this.mimeTypeDetector = original.getMimeTypeDetector();
+    }
+
+    /**
+     * Create a copy of the supplied execution context, but use the supplied {@link LoginContext} instead.
+     * 
+     * @param original the original
+     * @param loginContext the login context
+     * @throws IllegalArgumentException if the original or login context are is null
+     */
+    protected ExecutionContext( ExecutionContext original,
+                                LoginContext loginContext ) {
+        CheckArg.isNotNull(original, "original");
+        CheckArg.isNotNull(loginContext, "loginContext");
+        this.loginContext = loginContext;
+        this.accessControlContext = null;
+        this.subject = this.loginContext.getSubject();
+        this.namespaceRegistry = original.getNamespaceRegistry();
+        this.valueFactories = original.getValueFactories();
+        this.propertyFactory = original.getPropertyFactory();
+        this.classLoaderFactory = original.getClassLoaderFactory();
+        this.mimeTypeDetector = original.getMimeTypeDetector();
+    }
+
+    /**
+     * Create an instance of the execution context by supplying all parameters.
+     * 
+     * @param loginContext the login context, or null if the {@link #getSubject() subject} is to be retrieved from the
+     *        {@link AccessController#getContext() current calling context}.
+     * @param accessControlContext the access control context, or null if a {@link LoginContext} is provided or if the
+     *        {@link AccessController#getContext() current calling context} should be used
+     * @param namespaceRegistry the namespace registry implementation, or null if a {@link BasicNamespaceRegistry} instance should
+     *        be used
+     * @param valueFactories the {@link ValueFactories} implementation, or null if a {@link StandardValueFactories} instance
+     *        should be used
+     * @param propertyFactory the {@link PropertyFactory} implementation, or null if a {@link BasicPropertyFactory} instance
+     *        should be used
+     * @param mimeTypeDetector the {@link MimeTypeDetector} implementation, or null if an {@link ExtensionBasedMimeTypeDetector}
+     *        instance should be used
+     * @param classLoaderFactory the {@link ClassLoaderFactory} implementation, or null if a {@link StandardClassLoaderFactory}
+     *        instance should be used
+     */
+    protected ExecutionContext( LoginContext loginContext,
+                                AccessControlContext accessControlContext,
+                                NamespaceRegistry namespaceRegistry,
+                                ValueFactories valueFactories,
+                                PropertyFactory propertyFactory,
+                                MimeTypeDetector mimeTypeDetector,
+                                ClassLoaderFactory classLoaderFactory ) {
+        this.loginContext = loginContext;
+        this.accessControlContext = accessControlContext;
+        if (loginContext == null) {
+            this.subject = Subject.getSubject(accessControlContext == null ? AccessController.getContext() : accessControlContext);
+        } else {
+            this.subject = loginContext.getSubject();
+        }
+        this.namespaceRegistry = namespaceRegistry == null ? new BasicNamespaceRegistry() : namespaceRegistry;
+        this.valueFactories = valueFactories == null ? new StandardValueFactories(this.namespaceRegistry) : valueFactories;
+        this.propertyFactory = propertyFactory == null ? new BasicPropertyFactory(this.valueFactories) : propertyFactory;
+        this.classLoaderFactory = classLoaderFactory == null ? new StandardClassLoaderFactory() : classLoaderFactory;
+        this.mimeTypeDetector = mimeTypeDetector != null ? mimeTypeDetector : new ExtensionBasedMimeTypeDetector();
+    }
+
+    /**
+     * Get the class loader factory used by this context.
+     * 
+     * @return the class loader factory implementation; never null
+     */
+    protected ClassLoaderFactory getClassLoaderFactory() {
+        return classLoaderFactory;
+    }
+
+    /**
      * Return a logger associated with this context. This logger records only those activities within the context and provide a
      * way to capture the context-specific activities. All log messages are also sent to the system logger, so classes that log
      * via this mechanism should <i>not</i> also {@link Logger#getLogger(Class) obtain a system logger}.
@@ -58,7 +197,9 @@
      * @return the logger, named after <code>clazz</code>; never null
      * @see #getLogger(String)
      */
-    Logger getLogger( Class<?> clazz );
+    public Logger getLogger( Class<?> clazz ) {
+        return Logger.getLogger(clazz);
+    }
 
     /**
      * Return a logger associated with this context. This logger records only those activities within the context and provide a
@@ -69,45 +210,240 @@
      * @return the logger, named after <code>clazz</code>; never null
      * @see #getLogger(Class)
      */
-    Logger getLogger( String name );
+    public Logger getLogger( String name ) {
+        return Logger.getLogger(name);
+    }
 
     /**
      * Return an object that can be used to determine the MIME type of some content, such as the content of a file.
      * 
      * @return the detector; never null
      */
-    MimeTypeDetector getMimeTypeDetector();
+    public MimeTypeDetector getMimeTypeDetector() {
+        return this.mimeTypeDetector;
+    }
 
     /**
+     * Get the {@link AccessControlContext JAAS access control context} for this context.
+     * 
+     * @return the access control context; may be <code>null</code>
+     */
+    public AccessControlContext getAccessControlContext() {
+        return this.accessControlContext;
+    }
+
+    /**
+     * Get the {@link LoginContext JAAS login context} for this context.
+     * 
      * @return the login context; may be <code>null</code>
      */
-    LoginContext getLoginContext();
+    public LoginContext getLoginContext() {
+        return this.loginContext;
+    }
 
     /**
-     * Get the namespace registry for this context.
+     * Get the (mutable) namespace registry for this context.
      * 
      * @return the namespace registry; never <code>null</code>
      */
-    NamespaceRegistry getNamespaceRegistry();
+    public NamespaceRegistry getNamespaceRegistry() {
+        return this.namespaceRegistry;
+    }
 
     /**
      * Get the factory for creating {@link Property} objects.
      * 
      * @return the property factory; never <code>null</code>
      */
-    PropertyFactory getPropertyFactory();
+    public PropertyFactory getPropertyFactory() {
+        return this.propertyFactory;
+    }
 
     /**
      * Get the JAAS subject for which this context was created.
      * 
-     * @return the subject; never <code>null</code>
+     * @return the subject; should never be null if JAAS is used, but will be null if there is no
+     *         {@link #getAccessControlContext() access control context} or {@link #getLoginContext() login context}.
      */
-    Subject getSubject();
+    public Subject getSubject() {
+        return this.subject;
+    }
 
     /**
      * Get the factories that should be used to create values for {@link Property properties}.
      * 
      * @return the property value factory; never null
      */
-    ValueFactories getValueFactories();
+    public ValueFactories getValueFactories() {
+        return this.valueFactories;
+    }
+
+    /**
+     * {@inheritDoc}
+     * 
+     * @see org.jboss.dna.common.component.ClassLoaderFactory#getClassLoader(java.lang.String[])
+     */
+    public ClassLoader getClassLoader( String... classpath ) {
+        return this.classLoaderFactory.getClassLoader(classpath);
+    }
+
+    /**
+     * Create a new execution context that mirrors this context but that uses the supplied namespace registry. The resulting
+     * context's {@link #getValueFactories() value factories} and {@link #getPropertyFactory() property factory} all make use of
+     * the new namespace registry.
+     * 
+     * @param namespaceRegistry the new namespace registry implementation, or null if the default implementation should be used
+     * @return the new execution context
+     */
+    public ExecutionContext with( NamespaceRegistry namespaceRegistry ) {
+        // Don't supply the value factories or property factories, since they'll have to be recreated
+        // to reference the supplied namespace registry ...
+        return new ExecutionContext(this.getLoginContext(), this.getAccessControlContext(), namespaceRegistry, null, null,
+                                    this.getMimeTypeDetector(), this.getClassLoaderFactory());
+    }
+
+    /**
+     * Create a new execution context that mirrors this context but that uses the supplied {@link MimeTypeDetector MIME type
+     * detector}.
+     * 
+     * @param mimeTypeDetector the new MIME type detector implementation, or null if the default implementation should be used
+     * @return the new execution context
+     */
+    public ExecutionContext with( MimeTypeDetector mimeTypeDetector ) {
+        // Don't supply the value factories or property factories, since they'll have to be recreated
+        // to reference the supplied namespace registry ...
+        return new ExecutionContext(getLoginContext(), getAccessControlContext(), getNamespaceRegistry(), getValueFactories(),
+                                    getPropertyFactory(), mimeTypeDetector, getClassLoaderFactory());
+    }
+
+    /**
+     * Create a new execution context that mirrors this context but that uses the supplied {@link ClassLoaderFactory class loader
+     * factory}.
+     * 
+     * @param classLoaderFactory the new class loader factory implementation, or null if the default implementation should be used
+     * @return the new execution context
+     */
+    public ExecutionContext with( ClassLoaderFactory classLoaderFactory ) {
+        // Don't supply the value factories or property factories, since they'll have to be recreated
+        // to reference the supplied namespace registry ...
+        return new ExecutionContext(getLoginContext(), getAccessControlContext(), getNamespaceRegistry(), getValueFactories(),
+                                    getPropertyFactory(), getMimeTypeDetector(), classLoaderFactory);
+    }
+
+    /**
+     * Creates an {@link ExecutionContext} using the supplied {@link AccessControlContext access control context}.
+     * 
+     * @param accessControlContext An access control context.
+     * @return the execution context; never <code>null</code>.
+     * @throws IllegalArgumentException if <code>accessControlContext</code> is <code>null</code>.
+     */
+    public ExecutionContext create( AccessControlContext accessControlContext ) {
+        return new ExecutionContext(this, accessControlContext);
+    }
+
+    /**
+     * Create an {@link ExecutionContext} for the supplied {@link LoginContext}.
+     * 
+     * @param loginContext the JAAS login context
+     * @return the execution context
+     * @throws IllegalArgumentException if the <code>loginContext</code> is null
+     */
+    public ExecutionContext create( LoginContext loginContext ) {
+        return new ExecutionContext(this, loginContext);
+    }
+
+    /**
+     * @param name the name of the JAAS login context
+     * @return the execution context
+     * @throws IllegalArgumentException if the <code>name</code> is null
+     * @throws LoginException if there <code>name</code> is invalid (or there is no login context named "other"), or if the
+     *         default callback handler JAAS property was not set or could not be loaded
+     */
+    public ExecutionContext create( String name ) throws LoginException {
+        return new ExecutionContext(this, new LoginContext(name));
+    }
+
+    /**
+     * @param name the name of the JAAS login context
+     * @param subject the subject to authenticate
+     * @return the execution context
+     * @throws LoginException if there <code>name</code> is invalid (or there is no login context named "other"), if the default
+     *         callback handler JAAS property was not set or could not be loaded, or if the <code>subject</code> is null or
+     *         unknown
+     */
+    public ExecutionContext create( String name,
+                                    Subject subject ) throws LoginException {
+        return new ExecutionContext(this, new LoginContext(name, subject));
+    }
+
+    /**
+     * @param name the name of the JAAS login context
+     * @param callbackHandler the callback handler that will be used by {@link LoginModule}s to communicate with the user.
+     * @return the execution context
+     * @throws LoginException if there <code>name</code> is invalid (or there is no login context named "other"), or if the
+     *         <code>callbackHandler</code> is null
+     */
+    public ExecutionContext create( String name,
+                                    CallbackHandler callbackHandler ) throws LoginException {
+        return new ExecutionContext(this, new LoginContext(name, callbackHandler));
+    }
+
+    /**
+     * @param name the name of the JAAS login context
+     * @param subject the subject to authenticate
+     * @param callbackHandler the callback handler that will be used by {@link LoginModule}s to communicate with the user.
+     * @return the execution context
+     * @throws LoginException if there <code>name</code> is invalid (or there is no login context named "other"), if the default
+     *         callback handler JAAS property was not set or could not be loaded, if the <code>subject</code> is null or unknown,
+     *         or if the <code>callbackHandler</code> is null
+     */
+    public ExecutionContext create( String name,
+                                    Subject subject,
+                                    CallbackHandler callbackHandler ) throws LoginException {
+        return new ExecutionContext(this, new LoginContext(name, subject, callbackHandler));
+    }
+
+    /**
+     * {@inheritDoc}
+     * 
+     * @see org.jboss.dna.graph.ExecutionContextFactory#create()
+     */
+    public ExecutionContext create() {
+        return new ExecutionContext(this);
+    }
+
+    /**
+     * {@inheritDoc}
+     * 
+     * @see java.lang.Object#clone()
+     */
+    @Override
+    public ExecutionContext clone() {
+        return new ExecutionContext(this);
+    }
+
+    /**
+     * {@inheritDoc}
+     * 
+     * @see java.lang.Object#toString()
+     */
+    @Override
+    public String toString() {
+        return "Execution context for " + getSubject();
+    }
+
+    /**
+     * Method that initializes the default namespaces for namespace registries.
+     * 
+     * @param namespaceRegistry the namespace registry
+     */
+    protected void initializeDefaultNamespaces( NamespaceRegistry namespaceRegistry ) {
+        if (namespaceRegistry == null) return;
+        namespaceRegistry.register(JcrLexicon.Namespace.PREFIX, JcrLexicon.Namespace.URI);
+        namespaceRegistry.register(JcrMixLexicon.Namespace.PREFIX, JcrMixLexicon.Namespace.URI);
+        namespaceRegistry.register(JcrNtLexicon.Namespace.PREFIX, JcrNtLexicon.Namespace.URI);
+        namespaceRegistry.register(DnaLexicon.Namespace.PREFIX, DnaLexicon.Namespace.URI);
+        // namespaceRegistry.register("dnadtd", "http://www.jboss.org/dna/dtd/1.0");
+        // namespaceRegistry.register("dnaxml", "http://www.jboss.org/dna/xml/1.0");
+    }
 }
Index: dna-graph/src/main/java/org/jboss/dna/graph/mimetype/ExtensionBasedMimeTypeDetector.java
===================================================================
--- dna-graph/src/main/java/org/jboss/dna/graph/mimetype/ExtensionBasedMimeTypeDetector.java	(revision 702)
+++ dna-graph/src/main/java/org/jboss/dna/graph/mimetype/ExtensionBasedMimeTypeDetector.java	(working copy)
@@ -40,18 +40,7 @@
 @Immutable
 public class ExtensionBasedMimeTypeDetector implements MimeTypeDetector {
 
-    protected static final ExtensionBasedMimeTypeDetector DEFAULT_INSTANCE = new ExtensionBasedMimeTypeDetector();
-
     /**
-     * Get an immutable shared instance of this detector with the {@link #MIME_TYPE_EXTENSIONS_RESOURCE_PATH default mappings}.
-     * 
-     * @return the shared instance
-     */
-    public static ExtensionBasedMimeTypeDetector getInstance() {
-        return DEFAULT_INSTANCE;
-    }
-
-    /**
      * The default location of the properties file containing the extension patterns to MIME types.
      */
     public static final String MIME_TYPE_EXTENSIONS_RESOURCE_PATH = "/org/jboss/dna/graph/MimeTypes.properties";
Index: dna-graph/src/main/java/org/jboss/dna/graph/xml/XmlHandler.java
===================================================================
--- dna-graph/src/main/java/org/jboss/dna/graph/xml/XmlHandler.java	(revision 702)
+++ dna-graph/src/main/java/org/jboss/dna/graph/xml/XmlHandler.java	(working copy)
@@ -31,7 +31,6 @@
 import org.jboss.dna.common.text.TextDecoder;
 import org.jboss.dna.common.text.XmlNameEncoder;
 import org.jboss.dna.common.util.CheckArg;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.properties.Name;
 import org.jboss.dna.graph.properties.NameFactory;
@@ -202,7 +201,7 @@
 
         // Set up a local namespace registry that is kept in sync with the namespaces found in this XML document ...
         NamespaceRegistry namespaceRegistry = new LocalNamespaceRegistry(this.context.getNamespaceRegistry());
-        final ExecutionContext localContext = new BasicExecutionContext(this.context, namespaceRegistry);
+        final ExecutionContext localContext = this.context.with(namespaceRegistry);
 
         // Set up references to frequently-used objects in the context ...
         this.nameFactory = localContext.getValueFactories().getNameFactory();
